// Made with Amplify Shader Editor
// Available at the Unity Asset Store - http://u3d.as/y3X 
Shader "Highlight"
{
	Properties
	{
		_Hardness("Hardness", Float) = 10
		_Radius("Radius", Float) = 50
		[HideInInspector] __dirty( "", Int ) = 1
	}

	SubShader
	{
		Tags{ "RenderType" = "Transparent"  "Queue" = "Transparent+0" "IgnoreProjector" = "True" "IsEmissive" = "true"  }
		Cull Back
		ZWrite Off
		ZTest Always
		Blend SrcAlpha OneMinusSrcAlpha
		CGPROGRAM
		#include "UnityCG.cginc"
		#include "UnityShaderVariables.cginc"
		#pragma target 3.0
		#pragma surface surf Standard keepalpha noshadow vertex:vertexDataFunc 
		struct Input
		{
			float4 screenPos;
			float eyeDepth;
			float3 worldPos;
		};

		uniform sampler2D _CameraDepthTexture;
		uniform float _Radius;
		uniform float _Hardness;

		void vertexDataFunc( inout appdata_full v, out Input o )
		{
			UNITY_INITIALIZE_OUTPUT( Input, o );
			o.eyeDepth = -UnityObjectToViewPos( v.vertex.xyz ).z;
		}

		void surf( Input i , inout SurfaceOutputStandard o )
		{
			o.Emission = float4(0.8382353,0.04930795,0.04930795,0).rgb;
			float4 ase_screenPos = float4( i.screenPos.xyz , i.screenPos.w + 0.00000000001 );
			float eyeDepth14 = LinearEyeDepth(UNITY_SAMPLE_DEPTH(tex2Dproj(_CameraDepthTexture,UNITY_PROJ_COORD(ase_screenPos))));
			float3 ase_worldPos = i.worldPos;
			float4 transform3_g6 = mul(unity_ObjectToWorld,float4(0,0,0,1));
			float3 temp_output_69_0 = (transform3_g6).xyz;
			float4 transform50 = mul(unity_WorldToObject,float4( ( ase_worldPos - temp_output_69_0 ) , 0.0 ));
			float4 transform51 = mul(unity_WorldToObject,float4( ( _WorldSpaceCameraPos - temp_output_69_0 ) , 0.0 ));
			float4 temp_output_5_0_g32 = ( ( ( ( ( eyeDepth14 / i.eyeDepth ) * ( transform50 - transform51 ) ) + transform51 ) - float4( float3(0,0,0) , 0.0 ) ) / _Radius );
			float dotResult19_g32 = dot( temp_output_5_0_g32 , temp_output_5_0_g32 );
			float clampResult10_g32 = clamp( dotResult19_g32 , 0.0 , 1.0 );
			o.Alpha = pow( clampResult10_g32 , _Hardness );
		}

		ENDCG
	}
	CustomEditor "ASEMaterialInspector"
}
/*ASEBEGIN
Version=14101
7;29;1906;1103;2548.828;512.0189;1.446404;True;False
Node;AmplifyShaderEditor.FunctionNode;37;-2119.59,282.7693;Float;False;Actor Position;-1;;6;e71700e2930130546b76e9cf36cffc1d;0;1;FLOAT4;0
Node;AmplifyShaderEditor.WorldSpaceCameraPos;6;-2042.831,368.1584;Float;False;0;4;FLOAT3;0;FLOAT;1;FLOAT;2;FLOAT;3
Node;AmplifyShaderEditor.WorldPosInputsNode;1;-1977.984,112.801;Float;False;0;4;FLOAT3;0;FLOAT;1;FLOAT;2;FLOAT;3
Node;AmplifyShaderEditor.ComponentMaskNode;69;-1917.158,277.8001;Float;False;True;True;True;False;1;0;FLOAT4;0,0,0,0;False;1;FLOAT3;0
Node;AmplifyShaderEditor.SimpleSubtractOpNode;8;-1576.196,161.0495;Float;False;2;0;FLOAT3;0,0,0;False;1;FLOAT3;0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;False;1;FLOAT3;0
Node;AmplifyShaderEditor.SimpleSubtractOpNode;7;-1571.314,367.7139;Float;False;2;0;FLOAT3;0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;False;1;FLOAT3;0,0,0;False;1;FLOAT3;0
Node;AmplifyShaderEditor.SurfaceDepthNode;13;-1381.854,61.14791;Float;False;0;0;1;FLOAT;0
Node;AmplifyShaderEditor.ScreenDepthNode;14;-1380.68,-3.786304;Float;False;0;True;1;0;FLOAT4;0,0,0,0;False;1;FLOAT;0
Node;AmplifyShaderEditor.WorldToObjectTransfNode;51;-1404.346,368.1093;Float;False;1;0;FLOAT4;0,0,0,1;False;5;FLOAT4;0;FLOAT;1;FLOAT;2;FLOAT;3;FLOAT;4
Node;AmplifyShaderEditor.WorldToObjectTransfNode;50;-1399.346,162.1096;Float;False;1;0;FLOAT4;0,0,0,1;False;5;FLOAT4;0;FLOAT;1;FLOAT;2;FLOAT;3;FLOAT;4
Node;AmplifyShaderEditor.WireNode;46;-953.7072,377.9193;Float;False;1;0;FLOAT4;0,0,0,0;False;1;FLOAT4;0
Node;AmplifyShaderEditor.SimpleSubtractOpNode;11;-1115.6,246.3027;Float;False;2;0;FLOAT4;0,0,0,0;False;1;FLOAT4;0,0,0,0;False;1;FLOAT4;0
Node;AmplifyShaderEditor.SimpleDivideOpNode;15;-1105.321,37.52183;Float;False;2;0;FLOAT;0.0;False;1;FLOAT;0.0;False;1;FLOAT;0
Node;AmplifyShaderEditor.SimpleMultiplyOpNode;12;-942.2237,127.0242;Float;False;2;2;0;FLOAT;0,0,0,0;False;1;FLOAT4;0;False;1;FLOAT4;0
Node;AmplifyShaderEditor.WireNode;45;-817.0406,335.6664;Float;False;1;0;FLOAT4;0,0,0,0;False;1;FLOAT4;0
Node;AmplifyShaderEditor.SimpleAddOpNode;17;-724.361,129.1622;Float;False;2;2;0;FLOAT4;0,0,0,0;False;1;FLOAT4;0,0,0,0;False;1;FLOAT4;0
Node;AmplifyShaderEditor.RangedFloatNode;28;-602.7352,392.5591;Float;False;Property;_Radius;Radius;2;0;Create;50;0;0;0;1;FLOAT;0
Node;AmplifyShaderEditor.Vector3Node;30;-619.2559,252.1588;Float;False;Constant;_Vector1;Vector 1;3;0;Create;0,0,0;0;4;FLOAT3;0;FLOAT;1;FLOAT;2;FLOAT;3
Node;AmplifyShaderEditor.RangedFloatNode;53;-600.6086,521.5501;Float;False;Property;_Hardness;Hardness;1;0;Create;10;0;0;0;1;FLOAT;0
Node;AmplifyShaderEditor.ColorNode;21;-328.5793,-101.5327;Float;False;Constant;_Color;Color;0;0;Create;0.8382353,0.04930795,0.04930795,0;0;5;COLOR;0;FLOAT;1;FLOAT;2;FLOAT;3;FLOAT;4
Node;AmplifyShaderEditor.FunctionNode;81;-357.0541,185.9819;Float;False;SphereMask;-1;;32;988803ee12caf5f4690caee3c8c4a5bb;4;16;FLOAT4;0;False;15;FLOAT3;0;False;14;FLOAT;0.0;False;12;FLOAT;0.0;False;1;FLOAT;0
Node;AmplifyShaderEditor.StandardSurfaceOutputNode;84;0,0;Float;False;True;2;Float;ASEMaterialInspector;0;0;Standard;Highlight;False;False;False;False;False;False;False;False;False;False;False;False;False;False;True;False;False;Back;2;7;False;0;0;Custom;0.5;True;False;0;True;Transparent;Transparent;All;True;True;True;True;True;True;True;True;True;True;True;True;True;True;True;True;True;False;0;255;255;0;0;0;0;0;0;0;0;False;2;15;10;25;False;0.5;False;2;SrcAlpha;OneMinusSrcAlpha;0;Zero;Zero;OFF;OFF;0;False;0;0,0,0,0;VertexOffset;True;False;Cylindrical;False;Relative;0;;0;-1;-1;-1;0;0;0;False;0;0;16;0;FLOAT3;0,0,0;False;1;FLOAT3;0,0,0;False;2;FLOAT3;0,0,0;False;3;FLOAT;0.0;False;4;FLOAT;0.0;False;5;FLOAT;0.0;False;6;FLOAT3;0,0,0;False;7;FLOAT3;0,0,0;False;8;FLOAT;0.0;False;9;FLOAT;0.0;False;10;FLOAT;0.0;False;13;FLOAT3;0,0,0;False;11;FLOAT3;0,0,0;False;12;FLOAT3;0,0,0;False;14;FLOAT4;0,0,0,0;False;15;FLOAT3;0,0,0;False;0
WireConnection;69;0;37;0
WireConnection;8;0;1;0
WireConnection;8;1;69;0
WireConnection;7;0;6;0
WireConnection;7;1;69;0
WireConnection;51;0;7;0
WireConnection;50;0;8;0
WireConnection;46;0;51;0
WireConnection;11;0;50;0
WireConnection;11;1;51;0
WireConnection;15;0;14;0
WireConnection;15;1;13;0
WireConnection;12;0;15;0
WireConnection;12;1;11;0
WireConnection;45;0;46;0
WireConnection;17;0;12;0
WireConnection;17;1;45;0
WireConnection;81;16;17;0
WireConnection;81;15;30;0
WireConnection;81;14;28;0
WireConnection;81;12;53;0
WireConnection;84;2;21;0
WireConnection;84;9;81;0
ASEEND*/
//CHKSM=DB161703423F3EDC41A238A155AA2EBEBC24F1BA